'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _propTypes = require('prop-types');

var _propTypes2 = _interopRequireDefault(_propTypes);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _Editor = require('./Editor');

var _Editor2 = _interopRequireDefault(_Editor);

var _Item = require('./Item');

var _Item2 = _interopRequireDefault(_Item);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

var List = function (_React$Component) {
  _inherits(List, _React$Component);

  function List(props) {
    _classCallCheck(this, List);

    var _this = _possibleConstructorReturn(this, (List.__proto__ || Object.getPrototypeOf(List)).call(this, props));

    _this.state = {
      adding: false,
      selected: null
    };
    _this.add = _this.add.bind(_this);
    _this.addItem = _this.addItem.bind(_this);
    _this.addItemCancel = _this.addItemCancel.bind(_this);
    _this.onSelected = _this.onSelected.bind(_this);
    _this.removeItem = _this.removeItem.bind(_this);
    _this.updateItem = _this.updateItem(_this);
    return _this;
  }

  _createClass(List, [{
    key: 'add',
    value: function add() {
      this.setState({ adding: true, selected: this.props.newItem() });
    }
  }, {
    key: 'addButton',
    value: function addButton() {
      var id = this.props.id;

      return _react2.default.createElement(
        'button',
        { id: 'addButton_' + id, type: 'button', className: 'btn btn-default btn-xs', onClick: this.add },
        _react2.default.createElement('span', { className: 'glyphicon glyphicon-plus', 'aria-hidden': 'true' }),
        'Add'
      );
    }
  }, {
    key: 'addItem',
    value: function addItem(item) {
      this.props.addItem(item);
      this.setState({
        adding: false,
        selected: {}
      });
    }
  }, {
    key: 'addItemCancel',
    value: function addItemCancel() {
      this.setState({
        adding: false,
        selected: {}
      });
    }
  }, {
    key: 'form',
    value: function form() {
      var _props = this.props,
          formElements = _props.formElements,
          onChange = _props.onChange;

      return _react2.default.createElement(_Editor2.default, { id: 'new_item',
        onCancel: this.addItemCancel,
        onChange: onChange,
        onSave: this.addItem,
        formElements: formElements,
        item: this.state.selected });
    }
  }, {
    key: 'onSelected',
    value: function onSelected(item) {
      this.setState({
        selected: item
      });
      this.props.onSelected(item);
    }

    /*
                                       */

  }, {
    key: 'render',
    value: function render() {
      var _this2 = this;

      var _props2 = this.props,
          body = _props2.body,
          formElements = _props2.formElements,
          header = _props2.header,
          id = _props2.id,
          list = _props2.list,
          onCancel = _props2.onCancel,
          onChange = _props2.onChange;
      var adding = this.state.adding;

      return _react2.default.createElement(
        'div',
        { id: 'list_ ' + id },
        adding ? this.form() : this.addButton(),
        _react2.default.createElement(
          'div',
          { id: 'list_group_' + id, className: 'list-group' },
          list.map(function (i, index) {
            return _react2.default.createElement(_Item2.default, { key: index,
              body: body,
              header: header,
              id: id,
              item: i,
              formElements: formElements,
              onCancel: onCancel,
              onChange: onChange,
              onSelected: _this2.onSelected,
              onSubmit: _this2.updateItem,
              remove: _this2.removeItem });
          })
        )
      );
    }
  }, {
    key: 'removeItem',
    value: function removeItem(item) {
      this.props.removeItem(item);
    }
  }, {
    key: 'updateItem',
    value: function updateItem(item) {
      this.props.updateItem(item);
    }
  }]);

  return List;
}(_react2.default.Component);

List.propTypes = {
  addItem: _propTypes2.default.func.isRequired,
  body: _propTypes2.default.node.isRequired,
  formElements: _propTypes2.default.node.isRequired,
  header: _propTypes2.default.node.isRequired,
  id: _propTypes2.default.string.isRequired,
  list: _propTypes2.default.array.isRequired,
  newItem: _propTypes2.default.func.isRequired,
  onCancel: _propTypes2.default.func.isRequired,
  onChange: _propTypes2.default.func.isRequired,
  onSelected: _propTypes2.default.func.isRequired,
  removeItem: _propTypes2.default.func.isRequired,
  updateItem: _propTypes2.default.func.isRequired
};
exports.default = List;